<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>folder_structure.cli &#8212; folder-structure 0.0.post1.dev1+g08229bb.d20231212 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=9da889c1"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for folder_structure.cli</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">This is a skeleton file that can serve as a starting point for a Python</span>
<span class="sd">console script. To run this script uncomment the following lines in the</span>
<span class="sd">``[options.entry_points]`` section in ``setup.cfg``::</span>

<span class="sd">    console_scripts =</span>
<span class="sd">         fibonacci = folder_structure.skeleton:run</span>

<span class="sd">Then run ``pip install .`` (or ``pip install -e .`` for editable mode)</span>
<span class="sd">which will install the command ``fibonacci`` inside your current environment.</span>

<span class="sd">Besides console scripts, the header (i.e. until ``_logger``...) of this file can</span>
<span class="sd">also be used as template for Python modules.</span>

<span class="sd">Note:</span>
<span class="sd">    This file can be renamed depending on your needs or safely removed if not needed.</span>

<span class="sd">References:</span>
<span class="sd">    - https://setuptools.pypa.io/en/latest/userguide/entry_point.html</span>
<span class="sd">    - https://pip.pypa.io/en/stable/reference/pip_install</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">argparse</span>
<span class="kn">import</span> <span class="nn">logging</span>
<span class="kn">import</span> <span class="nn">sys</span>

<span class="kn">from</span> <span class="nn">folder_structure</span> <span class="kn">import</span> <span class="n">__version__</span>
<span class="kn">from</span> <span class="nn">folder_structure.schema</span> <span class="kn">import</span> <span class="n">Schema</span>
<span class="kn">from</span> <span class="nn">pathlib</span> <span class="kn">import</span> <span class="n">Path</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="s2">&quot;Branden Kappes&quot;</span>
<span class="n">__copyright__</span> <span class="o">=</span> <span class="s2">&quot;Branden Kappes&quot;</span>
<span class="n">__license__</span> <span class="o">=</span> <span class="s2">&quot;MIT&quot;</span>

<span class="n">_logger</span> <span class="o">=</span> <span class="n">logging</span><span class="o">.</span><span class="n">getLogger</span><span class="p">(</span><span class="vm">__name__</span><span class="p">)</span>


<span class="c1"># ---- Python API ----</span>
<span class="c1"># The functions defined in this section can be imported by users in their</span>
<span class="c1"># Python scripts/interactive interpreter, e.g. via</span>
<span class="c1"># `from folder_structure.skeleton import fib`,</span>
<span class="c1"># when using this Python module as a library.</span>


<div class="viewcode-block" id="build">
<a class="viewcode-back" href="../../api/folder_structure.html#folder_structure.cli.build">[docs]</a>
<span class="k">def</span> <span class="nf">build</span><span class="p">(</span><span class="n">schema</span><span class="p">:</span> <span class="n">Schema</span><span class="p">,</span> <span class="n">obj</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">root</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
    <span class="n">schema</span><span class="p">[</span><span class="n">obj</span><span class="p">](</span><span class="n">name</span><span class="o">=</span><span class="n">name</span><span class="p">)</span><span class="o">.</span><span class="n">build</span><span class="p">(</span><span class="n">root</span><span class="o">=</span><span class="n">root</span><span class="p">)</span></div>



<span class="c1"># ---- CLI ----</span>
<span class="c1"># The functions defined in this section are wrappers around the main Python</span>
<span class="c1"># API allowing them to be called directly from the terminal as a CLI</span>
<span class="c1"># executable/script.</span>


<div class="viewcode-block" id="parse_args">
<a class="viewcode-back" href="../../api/folder_structure.html#folder_structure.cli.parse_args">[docs]</a>
<span class="k">def</span> <span class="nf">parse_args</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Parse command line parameters</span>

<span class="sd">    Args:</span>
<span class="sd">      args (List[str]): command line parameters as list of strings</span>
<span class="sd">          (for example  ``[&quot;--help&quot;]``).</span>

<span class="sd">    Returns:</span>
<span class="sd">      :obj:`argparse.Namespace`: command line parameters namespace</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">parser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span>
        <span class="n">description</span><span class="o">=</span><span class="s2">&quot;Builds an object based on its defintion in a schema.&quot;</span><span class="p">)</span>
    <span class="c1"># Positional</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;type&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Type of the item that is to be constructed.&quot;</span>
    <span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;name&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Name of the item that is to be constructed.&quot;</span>
    <span class="p">)</span>
    <span class="c1"># Options</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--schema&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The JSON-formatted file that contains the schema definition.&quot;</span>
    <span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--where&quot;</span><span class="p">,</span>
        <span class="n">dest</span><span class="o">=</span><span class="s2">&quot;root&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;.&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The parent folder into which the new object should be built. &quot;</span> \
             <span class="s2">&quot;Default: current directory.&quot;</span>
    <span class="p">)</span>
    <span class="c1"># Common options</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--version&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="s2">&quot;version&quot;</span><span class="p">,</span>
        <span class="n">version</span><span class="o">=</span><span class="sa">f</span><span class="s2">&quot;folder-structure </span><span class="si">{</span><span class="n">__version__</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">,</span>
    <span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;-v&quot;</span><span class="p">,</span>
        <span class="s2">&quot;--verbose&quot;</span><span class="p">,</span>
        <span class="n">dest</span><span class="o">=</span><span class="s2">&quot;loglevel&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;set loglevel to INFO&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="s2">&quot;store_const&quot;</span><span class="p">,</span>
        <span class="n">const</span><span class="o">=</span><span class="n">logging</span><span class="o">.</span><span class="n">INFO</span><span class="p">,</span>
    <span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;-vv&quot;</span><span class="p">,</span>
        <span class="s2">&quot;--very-verbose&quot;</span><span class="p">,</span>
        <span class="n">dest</span><span class="o">=</span><span class="s2">&quot;loglevel&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;set loglevel to DEBUG&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="s2">&quot;store_const&quot;</span><span class="p">,</span>
        <span class="n">const</span><span class="o">=</span><span class="n">logging</span><span class="o">.</span><span class="n">DEBUG</span><span class="p">,</span>
    <span class="p">)</span>
    <span class="k">return</span> <span class="n">parser</span><span class="o">.</span><span class="n">parse_args</span><span class="p">(</span><span class="n">args</span><span class="p">)</span></div>



<div class="viewcode-block" id="setup_logging">
<a class="viewcode-back" href="../../api/folder_structure.html#folder_structure.cli.setup_logging">[docs]</a>
<span class="k">def</span> <span class="nf">setup_logging</span><span class="p">(</span><span class="n">loglevel</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Setup basic logging</span>

<span class="sd">    Args:</span>
<span class="sd">      loglevel (int): minimum loglevel for emitting messages</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">logformat</span> <span class="o">=</span> <span class="s2">&quot;[</span><span class="si">%(asctime)s</span><span class="s2">] </span><span class="si">%(levelname)s</span><span class="s2">:</span><span class="si">%(name)s</span><span class="s2">:</span><span class="si">%(message)s</span><span class="s2">&quot;</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">basicConfig</span><span class="p">(</span>
        <span class="n">level</span><span class="o">=</span><span class="n">loglevel</span><span class="p">,</span> <span class="n">stream</span><span class="o">=</span><span class="n">sys</span><span class="o">.</span><span class="n">stdout</span><span class="p">,</span> <span class="nb">format</span><span class="o">=</span><span class="n">logformat</span><span class="p">,</span> <span class="n">datefmt</span><span class="o">=</span><span class="s2">&quot;%Y-%m-</span><span class="si">%d</span><span class="s2"> %H:%M:%S&quot;</span>
    <span class="p">)</span></div>



<div class="viewcode-block" id="main">
<a class="viewcode-back" href="../../api/folder_structure.html#folder_structure.cli.main">[docs]</a>
<span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Wrapper allowing :func:`fib` to be called with string arguments in a CLI fashion</span>

<span class="sd">    Instead of returning the value from :func:`fib`, it prints the result to the</span>
<span class="sd">    ``stdout`` in a nicely formatted message.</span>

<span class="sd">    Args:</span>
<span class="sd">      args (List[str]): command line parameters as list of strings</span>
<span class="sd">          (for example  ``[&quot;--verbose&quot;, &quot;42&quot;]``).</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">args</span> <span class="o">=</span> <span class="n">parse_args</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
    <span class="n">setup_logging</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">loglevel</span><span class="p">)</span>
    <span class="n">_logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Building </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="n">name</span><span class="si">!r}</span><span class="s2"> (type: </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="n">type</span><span class="si">!r}</span><span class="s2">) in </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="n">root</span><span class="si">!r}</span><span class="s2">.&quot;</span><span class="p">)</span>
    <span class="n">schema</span> <span class="o">=</span> <span class="n">Schema</span><span class="o">.</span><span class="n">generate</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">schema</span><span class="p">)</span>
    <span class="n">build</span><span class="p">(</span><span class="n">schema</span><span class="p">,</span> <span class="n">args</span><span class="o">.</span><span class="n">type</span><span class="p">,</span> <span class="n">args</span><span class="o">.</span><span class="n">name</span><span class="p">,</span> <span class="n">root</span><span class="o">=</span><span class="n">args</span><span class="o">.</span><span class="n">root</span><span class="p">)</span>
    <span class="n">_logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Finished.&quot;</span><span class="p">)</span></div>



<div class="viewcode-block" id="run">
<a class="viewcode-back" href="../../api/folder_structure.html#folder_structure.cli.run">[docs]</a>
<span class="k">def</span> <span class="nf">run</span><span class="p">():</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Calls :func:`main` passing the CLI arguments extracted from :obj:`sys.argv`</span>

<span class="sd">    This function can be used as entry point to create console scripts with setuptools.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">main</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">:])</span></div>



<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="c1"># ^  This is a guard statement that will prevent the following code from</span>
    <span class="c1">#    being executed in the case someone imports this file instead of</span>
    <span class="c1">#    executing it as a script.</span>
    <span class="c1">#    https://docs.python.org/3/library/__main__.html</span>

    <span class="c1"># After installing your project with pip, users can also run your Python</span>
    <span class="c1"># modules as scripts via the ``-m`` flag, as defined in PEP 338::</span>
    <span class="c1">#</span>
    <span class="c1">#     python -m folder_structure.skeleton 42</span>
    <span class="c1">#</span>
    <span class="n">run</span><span class="p">()</span>
</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">folder-structure</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../readme.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../changelog.html">Changelog</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../api/modules.html">Module Reference</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Branden Kappes.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>